package script

import (
	"net/http"

	"github.com/cjoudrey/gluahttp"
	"github.com/cjoudrey/gluaurl"
	"github.com/kohkimakimoto/gluayaml"
	ljson "github.com/layeh/gopher-json"
	"github.com/layeh/gopher-lfs"
	"github.com/yuin/gluare"
	"github.com/yuin/gopher-lua"
)

func InitLua() (l *lua.LState) {
	l = lua.NewState()

	l.PreloadModule("re", gluare.Loader)
	l.PreloadModule("http", gluahttp.NewHttpModule(&http.Client{}).Loader)
	l.PreloadModule("json", ljson.Loader)
	l.PreloadModule("yaml", gluayaml.Loader)
	l.PreloadModule("url", gluaurl.Loader)

	lfs.Preload(l)

	return
}
